<?php

/**
 * Magento
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@magentocommerce.com so we can send you a copy immediately.
 *
 * This file controls the webxmore_pelecard/form.phtml from comments folder
 * 
 * @company     WebXMore
 * @package     Webxmore_Pelecard
 * @copyright   Copyright (c) 2014 WebXMore 
 * @license     http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Webxmore_PayMe_Block_Form extends Mage_Core_Block_Template {

    var $_result;
    
    var $_order;

    protected function _construct() {
        parent::_construct();
        $this->setTemplate('wbxpm/form.phtml');
        $this->_order = Mage::getModel('sales/order')->load(Mage::getSingleton('checkout/session')->getLastOrderId());
        $this->_result = Mage::helper("wbxpm")->createSale($this->_order);
    }

    public function isSuccess() {
        return ($this->_result["status_code"] == 0);
    }

    public function getErrorMessage() {
        return $this->_result["status_error_details"];
    }

    public function getUrl() {
        $params = array(
            'email' => $this->_order->getBillingAddress()->getEmail(),
            'phone' => $this->_order->getShippingAddress()->getTelephone(),
            'first_name' => $this->_order->getShippingAddress()->getFirstname(),
            'last_name' => $this->_order->getShippingAddress()->getLastname(),
        );
        
        Mage::log($params, null, "conf");
        $con = array();
        foreach ($params as $key => $param) {
            $con[] = implode("=", array($key, $param));
        }
        return $this->_result["sale_url"]."?".implode("&", $con);
    }

}
