<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of Data
 *
 * @author kryuch
 */
class Webxmore_PayMe_Helper_Data extends Mage_Payment_Helper_Data {

    function createInvoice($order) {
        if (!$order->canInvoice()) {
            Mage::log("Can't create invoice");
        }

	          $order->sendNewOrderEmail();
                $order->setEmailSent(true);

        $invoice = Mage::getModel("sales/service_order", $order)->prepareInvoice();
        if (!$invoice->getTotalQty()) {
            Mage::log("No price");
        }
        $invoice->setRequestedCaptureCase(Mage_Sales_Model_Order_Invoice::CAPTURE_ONLINE);
        $invoice->register();
        $transactionSave = Mage::getModel('core/resource_transaction')
                ->addObject($invoice)
                ->addObject($invoice->getOrder());
        $invoice->sendEmail();
        $transactionSave->save();
    }

    function getParam($key) {
        $store = Mage::app()->getStore();
        $value = Mage::getStoreConfig("payment/wbxpm_acc/$key", $store);
        return ($value == "") ? Mage::getStoreConfig("payment/wbxpm/$key", $store) : $value;
    }

    function getSeleUrl() {
        if ($this->getParam("debug")) {
            return "https://preprod.paymeservice.com/api/generate-sale";
        } else {
            return "https://ng.paymeservice.com/api/generate-sale";
        }
    }

    function createSale($order) {

        $products = array();
        foreach ($order->getAllItems() as $item) {
            $products[] = $item->getName();
        }

        $params = array(
            "language" => $this->getParam("lang"),
            "currency" => $this->getParam("currency"),
            "seller_payme_id" => $this->getParam("debug") ? $this->getParam("debugkey") : $this->getParam("productionkey"),
            'product_name' => implode(";", $products),
            'sale_price' => round($order->getGrandTotal() * 100),
            'installments' => $this->maxPaymentsNumber($order->getGrandTotal()),
            'sale_callback_url' => Mage::getUrl("wbxpm/processing/success", array("order" => $order->getId())),
            'sale_return_url' => Mage::getUrl("wbxpm/processing/success", array("order" => $order->getId())),
            'transaction_id' => $order->getIncrementId()
        );
        
        if (trim($this->getParam("callback"))) $params["callback"] = $this->getParam("callback");
        if (trim($this->getParam("layout"))) $params["layout"] = $this->getParam("layout");
        $report = $this->request($params, $this->getSeleUrl());
        return $report;
    }

    function request($params, $url) {
        $this->log($params, "Request");

        $ch = curl_init();

        $json = array();
        foreach ($params as $param => $val)
            $json['"' . $param . '"'] = $val;

        $this->log(json_encode($params), "Request");

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);

        curl_setopt($ch, CURLOPT_POST, TRUE);

        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));

        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            "Content-Type: application/json"
        ));

        $response = curl_exec($ch);
        curl_close($ch);
        $result = json_decode($response, true);
        $this->log($result, "Report");
        return $result;
    }

    public function log($text, $title) {
        if ($this->getParam("log")) {
            Mage::log($title, null, "wbxpm");
            Mage::log("***************************", null, "wbxpm");
            Mage::log($text, null, "wbxpm");
            Mage::log("", null, "wbxpm");
        }
    }

    public function generateAlias() {
        $s = substr(str_shuffle(str_repeat($x = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ', ceil(10 / strlen($x)))), 1, 10);
        return time() . $s;
    }

    private function maxPaymentsNumber($amount = false) {
//        if ($this->getParam('currency') != "ILS") return 1;

        if ($this->getParam('installments_setting') == 1) return $this->getParam('installments_preset');
        
        foreach (array_reverse(json_decode($this->getParam('installments'), true)) as $index => $item) {
            if ($amount >= $item[0] && $amount <= $item[1])
                return 100 + (4 - $index) * 3;
        }
        return 1;
    }

}
